// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Stream;
use glib::object::Cast;
use glib::object::IsA;
use glib::translate::*;
use std::fmt;

glib::wrapper! {
    #[doc(alias = "GMimeStreamGIO")]
    pub struct StreamGIO(Object<ffi::GMimeStreamGIO, ffi::GMimeStreamGIOClass>) @extends Stream;

    match fn {
        type_ => || ffi::g_mime_stream_gio_get_type(),
    }
}

impl StreamGIO {
    #[doc(alias = "g_mime_stream_gio_new")]
    pub fn new(file: &impl IsA<gio::File>) -> StreamGIO {
        assert_initialized_main_thread!();
        unsafe {
            Stream::from_glib_full(ffi::g_mime_stream_gio_new(file.as_ref().to_glib_none().0))
                .unsafe_cast()
        }
    }

    #[doc(alias = "g_mime_stream_gio_new_with_bounds")]
    #[doc(alias = "new_with_bounds")]
    pub fn with_bounds(file: &impl IsA<gio::File>, start: i64, end: i64) -> StreamGIO {
        assert_initialized_main_thread!();
        unsafe {
            Stream::from_glib_full(ffi::g_mime_stream_gio_new_with_bounds(
                file.as_ref().to_glib_none().0,
                start,
                end,
            ))
            .unsafe_cast()
        }
    }
}

pub const NONE_STREAM_GIO: Option<&StreamGIO> = None;

pub trait StreamGIOExt: 'static {
    #[doc(alias = "g_mime_stream_gio_get_owner")]
    #[doc(alias = "get_owner")]
    fn is_owner(&self) -> bool;

    #[doc(alias = "g_mime_stream_gio_set_owner")]
    fn set_owner(&self, owner: bool);
}

impl<O: IsA<StreamGIO>> StreamGIOExt for O {
    fn is_owner(&self) -> bool {
        unsafe {
            from_glib(ffi::g_mime_stream_gio_get_owner(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn set_owner(&self, owner: bool) {
        unsafe {
            ffi::g_mime_stream_gio_set_owner(self.as_ref().to_glib_none().0, owner.into_glib());
        }
    }
}

impl fmt::Display for StreamGIO {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("StreamGIO")
    }
}
